package com.ruoyi.clock.service;

import com.ruoyi.clock.domain.Employee;
import com.ruoyi.clock.domain.bo.EmployeePasswordBo;
import com.ruoyi.clock.domain.bo.EmployeeStatusBo;
import com.ruoyi.clock.domain.vo.EmployeeVo;
import com.ruoyi.clock.domain.bo.EmployeeBo;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 店员信息Service接口
 *
 * @author pengc
 * @date 2026-03-04
 */
public interface IEmployeeService {

    /**
     * 查询店员信息分页
     *
     * @param bo 店员信息
     * @return 店员信息集合
     */
    TableDataInfo<EmployeeVo> queryPageList(EmployeeBo bo, PageQuery pageQuery);

    /**
     * 查询店员信息列表
     *
     * @param bo 店员信息
     * @return 店员信息集合
     */
    List<EmployeeVo> queryList(EmployeeBo bo);

    /**
     * 查询店员信息
     *
     * @param employeeId 店员信息主键
     * @return 店员信息
     */
    EmployeeVo queryById(Long employeeId);

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    Employee selectUserByUserName(String userName);

    /**
     * 详情店员信息
     *
     * @param employeeId 店员信息主键
     * @return 店员信息
     */
    Employee loadById(Long employeeId, Boolean tw);

    /**
     * 新增店员信息
     *
     * @param bo 店员信息
     * @return 结果
     */
    Boolean insertByBo(EmployeeBo bo);

    /**
     * 修改店员信息
     *
     * @param bo 店员信息
     * @return 结果
     */
    Boolean updateByBo(EmployeeBo bo);

    /**
     * 重置密码
     *
     * @param employeeId 店员信息主键
     * @return 结果
     */
    Boolean resetPwd(Long employeeId);

    /**
     * 重置密码
     *
     * @param bo 店员信息
     * @return 结果
     */
    Boolean updatePwd(EmployeePasswordBo bo);

    /**
     * 更新店员状态
     * @param bo
     * @return
     */
    Boolean updateStatus(EmployeeStatusBo bo);

    /**
     * 校验并批量删除店员信息信息
     *
     * @param ids 需要删除的店员信息主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

}
